var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import { useEffect, useRef } from 'react';
var BarChart = function (props) {
    var chartRef = useRef(null);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    var serials = new Set();
    var xValues = new Set();
    if (props.chartData && Array.isArray(props.chartData)) {
        props.chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37, _38, _39, _40, _41;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: ((_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.legend) === null || _b === void 0 ? void 0 : _b.show) || false,
                orient: ((_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.legend) === null || _d === void 0 ? void 0 : _d.orient) || 'horizontal',
                left: ((_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.legend) === null || _f === void 0 ? void 0 : _f.left) || 'auto',
                right: ((_h = (_g = props.setup.chart) === null || _g === void 0 ? void 0 : _g.legend) === null || _h === void 0 ? void 0 : _h.right) || 'auto',
                top: ((_k = (_j = props.setup.chart) === null || _j === void 0 ? void 0 : _j.legend) === null || _k === void 0 ? void 0 : _k.top) || 'auto',
                bottom: ((_m = (_l = props.setup.chart) === null || _l === void 0 ? void 0 : _l.legend) === null || _m === void 0 ? void 0 : _m.bottom) || 'auto',
            },
            tooltip: {
                show: ((_p = (_o = props.setup.chart) === null || _o === void 0 ? void 0 : _o.tooltip) === null || _p === void 0 ? void 0 : _p.show) || false,
                trigger: ((_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.tooltip) === null || _r === void 0 ? void 0 : _r.trigger) || 'item',
                backgroundColor: ((_t = (_s = props.setup.chart) === null || _s === void 0 ? void 0 : _s.tooltip) === null || _t === void 0 ? void 0 : _t.backgroundColor) || '#000',
                borderRadius: ((_v = (_u = props.setup.chart) === null || _u === void 0 ? void 0 : _u.tooltip) === null || _v === void 0 ? void 0 : _v.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_y = (_x = (_w = props.setup.chart) === null || _w === void 0 ? void 0 : _w.tooltip) === null || _x === void 0 ? void 0 : _x.textStyle) === null || _y === void 0 ? void 0 : _y.fontSize) || 'normal',
                    color: ((_1 = (_0 = (_z = props.setup.chart) === null || _z === void 0 ? void 0 : _z.tooltip) === null || _0 === void 0 ? void 0 : _0.textStyle) === null || _1 === void 0 ? void 0 : _1.color) || '#fff',
                },
            },
            dataset: {
                source: __spreadArray([
                    __spreadArray([(_3 = (_2 = props.setup.chart) === null || _2 === void 0 ? void 0 : _2.seri) === null || _3 === void 0 ? void 0 : _3.field], Array.from(serials), true)
                ], Array.from(xValues).map(function (xValue) { return __spreadArray([
                    xValue
                ], Array.from(serials).map(function (serial) {
                    var _a, _b, _c, _d;
                    return ((_b = (_a = props.chartData) === null || _a === void 0 ? void 0 : _a.find(function (item) {
                        var _a, _b, _c, _d;
                        return item[(_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field] === serial &&
                            item[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field] === xValue;
                    })) === null || _b === void 0 ? void 0 : _b[(_d = (_c = props.setup.chart) === null || _c === void 0 ? void 0 : _c.y_axis) === null || _d === void 0 ? void 0 : _d.field]) || 0;
                }), true); }), true),
            },
            xAxis: props.setup.type === 'vertical-bar-chart'
                ? {
                    type: 'category',
                    min: ((_5 = (_4 = props.setup.chart) === null || _4 === void 0 ? void 0 : _4.x_axis) === null || _5 === void 0 ? void 0 : _5.min) || undefined,
                    max: ((_7 = (_6 = props.setup.chart) === null || _6 === void 0 ? void 0 : _6.x_axis) === null || _7 === void 0 ? void 0 : _7.max) || undefined,
                    axisLabel: {
                        rotate: ((_10 = (_9 = (_8 = props.setup.chart) === null || _8 === void 0 ? void 0 : _8.x_axis) === null || _9 === void 0 ? void 0 : _9.axisLabel) === null || _10 === void 0 ? void 0 : _10.rotate) || 0,
                    },
                    splitLine: {
                        lineStyle: {
                            color: ((_14 = (_13 = (_12 = (_11 = props.setup.chart) === null || _11 === void 0 ? void 0 : _11.x_axis) === null || _12 === void 0 ? void 0 : _12.splitLine) === null || _13 === void 0 ? void 0 : _13.lineStyle) === null || _14 === void 0 ? void 0 : _14.color) || '#e9e9eb',
                            type: ((_18 = (_17 = (_16 = (_15 = props.setup.chart) === null || _15 === void 0 ? void 0 : _15.x_axis) === null || _16 === void 0 ? void 0 : _16.splitLine) === null || _17 === void 0 ? void 0 : _17.lineStyle) === null || _18 === void 0 ? void 0 : _18.type) || 'solid',
                            width: ((_22 = (_21 = (_20 = (_19 = props.setup.chart) === null || _19 === void 0 ? void 0 : _19.x_axis) === null || _20 === void 0 ? void 0 : _20.splitLine) === null || _21 === void 0 ? void 0 : _21.lineStyle) === null || _22 === void 0 ? void 0 : _22.width) || 1,
                        },
                    },
                }
                : {},
            yAxis: props.setup.type === 'vertical-bar-chart'
                ? {}
                : {
                    type: 'category',
                    min: ((_24 = (_23 = props.setup.chart) === null || _23 === void 0 ? void 0 : _23.y_axis) === null || _24 === void 0 ? void 0 : _24.min) || undefined,
                    max: ((_26 = (_25 = props.setup.chart) === null || _25 === void 0 ? void 0 : _25.y_axis) === null || _26 === void 0 ? void 0 : _26.max) || undefined,
                    axisLabel: {
                        rotate: ((_29 = (_28 = (_27 = props.setup.chart) === null || _27 === void 0 ? void 0 : _27.y_axis) === null || _28 === void 0 ? void 0 : _28.axisLabel) === null || _29 === void 0 ? void 0 : _29.rotate) || 0,
                    },
                    splitLine: {
                        lineStyle: {
                            color: ((_33 = (_32 = (_31 = (_30 = props.setup.chart) === null || _30 === void 0 ? void 0 : _30.y_axis) === null || _31 === void 0 ? void 0 : _31.splitLine) === null || _32 === void 0 ? void 0 : _32.lineStyle) === null || _33 === void 0 ? void 0 : _33.color) || '#e9e9eb',
                            type: ((_37 = (_36 = (_35 = (_34 = props.setup.chart) === null || _34 === void 0 ? void 0 : _34.y_axis) === null || _35 === void 0 ? void 0 : _35.splitLine) === null || _36 === void 0 ? void 0 : _36.lineStyle) === null || _37 === void 0 ? void 0 : _37.type) || 'solid',
                            width: ((_41 = (_40 = (_39 = (_38 = props.setup.chart) === null || _38 === void 0 ? void 0 : _38.y_axis) === null || _39 === void 0 ? void 0 : _39.splitLine) === null || _40 === void 0 ? void 0 : _40.lineStyle) === null || _41 === void 0 ? void 0 : _41.width) || 1,
                        },
                    },
                },
            series: Array.from(serials).map(function (value, index) {
                var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8;
                return {
                    type: 'bar',
                    itemStyle: {
                        color: ((_d = (_c = (_b = (_a = props.setup.chart) === null || _a === void 0 ? void 0 : _a.item_styles) === null || _b === void 0 ? void 0 : _b[index]) === null || _c === void 0 ? void 0 : _c.style) === null || _d === void 0 ? void 0 : _d.bg_to_color)
                            ? {
                                type: 'linear',
                                x: 0,
                                y: 0,
                                x2: 0,
                                y2: 1,
                                colorStops: [
                                    {
                                        offset: 0,
                                        color: (_j = (_h = (_g = (_f = (_e = props.setup.chart) === null || _e === void 0 ? void 0 : _e.item_styles) === null || _f === void 0 ? void 0 : _f[index]) === null || _g === void 0 ? void 0 : _g.style) === null || _h === void 0 ? void 0 : _h.bg_color) !== null && _j !== void 0 ? _j : '#5470c6',
                                    },
                                    {
                                        offset: 1,
                                        color: (_p = (_o = (_m = (_l = (_k = props.setup.chart) === null || _k === void 0 ? void 0 : _k.item_styles) === null || _l === void 0 ? void 0 : _l[index]) === null || _m === void 0 ? void 0 : _m.style) === null || _o === void 0 ? void 0 : _o.bg_to_color) !== null && _p !== void 0 ? _p : '#91cc75',
                                    },
                                ],
                            }
                            : ((_u = (_t = (_s = (_r = (_q = props.setup.chart) === null || _q === void 0 ? void 0 : _q.item_styles) === null || _r === void 0 ? void 0 : _r[index]) === null || _s === void 0 ? void 0 : _s.style) === null || _t === void 0 ? void 0 : _t.bg_color) !== null && _u !== void 0 ? _u : '#5470c6'),
                        borderRadius: (_z = (_y = (_x = (_w = (_v = props.setup.chart) === null || _v === void 0 ? void 0 : _v.item_styles) === null || _w === void 0 ? void 0 : _w[index]) === null || _x === void 0 ? void 0 : _x.style) === null || _y === void 0 ? void 0 : _y.border_radius) !== null && _z !== void 0 ? _z : 0,
                        borderColor: (_4 = (_3 = (_2 = (_1 = (_0 = props.setup.chart) === null || _0 === void 0 ? void 0 : _0.item_styles) === null || _1 === void 0 ? void 0 : _1[index]) === null || _2 === void 0 ? void 0 : _2.style) === null || _3 === void 0 ? void 0 : _3.line_color) !== null && _4 !== void 0 ? _4 : undefined,
                        borderWidth: ((_8 = (_7 = (_6 = (_5 = props.setup.chart) === null || _5 === void 0 ? void 0 : _5.item_styles) === null || _6 === void 0 ? void 0 : _6[index]) === null || _7 === void 0 ? void 0 : _7.style) === null || _8 === void 0 ? void 0 : _8.line_color) ? 2 : 0,
                    },
                };
            }),
        };
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption() });
};
export default BarChart;
