import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import React from 'react';
import Pagination from '../components/Pagination.js';
var Table = function (props) {
    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
    var _k = React.useState(1), currentPage = _k[0], setCurrentPage = _k[1];
    var _l = React.useState((_b = (_a = props.setup.table) === null || _a === void 0 ? void 0 : _a.page_size) !== null && _b !== void 0 ? _b : 10), rowsPerPage = _l[0], setRowsPerPage = _l[1];
    var pageSizes = ((_c = props.setup.table) === null || _c === void 0 ? void 0 : _c.page_sizes)
        ? (_e = (_d = props.setup.table) === null || _d === void 0 ? void 0 : _d.page_sizes) === null || _e === void 0 ? void 0 : _e.filter(function (size) { return size !== null && size !== undefined; })
        : undefined;
    var tableColumnsOption = Array.isArray((_f = props.setup.table) === null || _f === void 0 ? void 0 : _f.columns)
        ? props.setup.table.columns
        : [];
    var startIndex = (currentPage - 1) * rowsPerPage;
    var endIndex = startIndex + rowsPerPage;
    var currentData = (_h = (_g = props.chartData) === null || _g === void 0 ? void 0 : _g.slice(startIndex, endIndex)) !== null && _h !== void 0 ? _h : [];
    var totalPages = Math.ceil((((_j = props.chartData) === null || _j === void 0 ? void 0 : _j.length) || 0) / rowsPerPage);
    var handlePageChange = function (page) {
        var _a;
        setCurrentPage(page);
        (_a = props.onPageChange) === null || _a === void 0 ? void 0 : _a.call(props, page);
    };
    var handlePageSizeChange = function (pageSize) {
        var _a, _b;
        setRowsPerPage(pageSize);
        (_a = props.onPageSizeChange) === null || _a === void 0 ? void 0 : _a.call(props, pageSize);
        setCurrentPage(1);
        (_b = props.onPageChange) === null || _b === void 0 ? void 0 : _b.call(props, 1);
    };
    var caculateWidth = function (width) {
        if (!width)
            return 'auto';
        var totalWidth = tableColumnsOption.reduce(function (sum, col) { return sum + (col.width || 0); }, 0);
        return "".concat((width / totalWidth) * 100, "%");
    };
    return (_jsxs(_Fragment, { children: [_jsx("div", { className: "stable-component", children: _jsxs("table", { border: 1, style: { width: '100%', borderCollapse: 'collapse' }, children: [_jsx("thead", { children: _jsx("tr", { children: tableColumnsOption.map(function (option) { return (_jsx("th", { style: {
                                        position: 'sticky',
                                        top: 0,
                                        backgroundColor: '#f5f7fa',
                                        fontWeight: 'bold',
                                        textTransform: 'capitalize',
                                        zIndex: 1,
                                        minWidth: option.width ? "".concat(option.width, "px") : 'auto',
                                        width: caculateWidth(option.width),
                                    }, children: option.header_text || option.field }, option.field)); }) }) }), _jsx("tbody", { children: currentData.map(function (row, indexRow) { return (_jsx("tr", { children: tableColumnsOption.map(function (option) {
                                    var _a, _b, _c, _d, _e, _f, _g, _h;
                                    return (_jsx("td", { className: "".concat(((_a = option.styles) === null || _a === void 0 ? void 0 : _a.custom_class) || ''), style: {
                                            textAlign: ((_b = option.styles) === null || _b === void 0 ? void 0 : _b.text_align) || 'left',
                                            fontStyle: ((_c = option.styles) === null || _c === void 0 ? void 0 : _c.italic) ? 'italic' : 'normal',
                                            fontWeight: ((_d = option.styles) === null || _d === void 0 ? void 0 : _d.bold) ? 'bold' : 'normal',
                                            color: (_f = (_e = option.styles) === null || _e === void 0 ? void 0 : _e.text_color) !== null && _f !== void 0 ? _f : '#000',
                                            backgroundColor: (_h = (_g = option.styles) === null || _g === void 0 ? void 0 : _g.bg_color) !== null && _h !== void 0 ? _h : '#ffffff',
                                            minWidth: option.width ? "".concat(option.width, "px") : 'auto',
                                        }, children: option.field && row[option.field] !== undefined && row[option.field] !== null
                                            ? row[option.field].toString()
                                            : '' }, option.field));
                                }) }, indexRow)); }) })] }) }), _jsx(Pagination, { currentPage: currentPage, totalPages: totalPages, onPageChange: handlePageChange, pageSizes: pageSizes, currentPageSize: rowsPerPage, onPageSizeChange: handlePageSizeChange })] }));
};
export default Table;
