import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React from 'react';
import { FaTable } from 'react-icons/fa';
import { FaChartBar } from 'react-icons/fa';
import { FaArrowAltCircleRight } from 'react-icons/fa';
import { FaFileExcel } from 'react-icons/fa';
import { FaFilter } from 'react-icons/fa';
import { formatDateForInput } from '../common/utils.js';
var ChartTitle = function (_a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    var setup = _a.setup, onToggleView = _a.onToggleView, handleLinkChart = _a.handleLinkChart, handleDownloadExcel = _a.handleDownloadExcel, onShowFilter = _a.onShowFilter, appliedFilters = _a.appliedFilters;
    if (setup.type.includes('chart')) {
        if (((_c = (_b = setup.chart) === null || _b === void 0 ? void 0 : _b.title) === null || _c === void 0 ? void 0 : _c.show) !== true)
            return null;
    }
    var _p = React.useState('chart'), viewMode = _p[0], setViewMode = _p[1];
    var _q = React.useState(''), filterDescription = _q[0], setFilterDescription = _q[1];
    function changeViewData(event) {
        event.stopPropagation();
        var newViewMode = viewMode === 'chart' ? 'table' : 'chart';
        setViewMode(newViewMode);
        onToggleView(newViewMode === 'table');
    }
    function nextDashboard(event) {
        var _a;
        event.stopPropagation();
        var chartLink = (_a = setup.chart) === null || _a === void 0 ? void 0 : _a.chart_link;
        if (chartLink && chartLink.length > 0) {
            return handleLinkChart({
                setup: setup,
                chart_link: chartLink,
                filter: appliedFilters,
            });
        }
    }
    function downloadFileExcel(event) {
        event.stopPropagation();
        return handleDownloadExcel();
    }
    function showFilter(event) {
        event.stopPropagation();
        onShowFilter();
    }
    React.useEffect(function () {
        var description = Object.entries(appliedFilters || {})
            .map(function (_a) {
            var _b;
            var key = _a[0], value = _a[1];
            var parameter = (_b = setup.parameters) === null || _b === void 0 ? void 0 : _b.find(function (param) { return (param === null || param === void 0 ? void 0 : param.code) === key; });
            var label = (parameter === null || parameter === void 0 ? void 0 : parameter.label) || key;
            var formattedValue = value;
            if ((parameter === null || parameter === void 0 ? void 0 : parameter.data_type) === 'date') {
                formattedValue = formatDateForInput(String(value), 'date', 'DD-MM-YYYY');
            }
            else if ((parameter === null || parameter === void 0 ? void 0 : parameter.data_type) === 'datetime') {
                formattedValue = formatDateForInput(String(value), 'datetime-local', 'DD-MM-YYYY');
            }
            return "".concat(label, ": ").concat(formattedValue);
        })
            .join('\n');
        setFilterDescription(description);
    }, [appliedFilters, setup.parameters]);
    return (_jsxs("div", { className: "s-dashboard__title", style: {
            display: 'flex',
            justifyContent: 'space-between',
            alignItems: 'center',
        }, children: [_jsxs("div", { className: "s-dashboard__title--text", children: [_jsx("p", { className: "s-dashboard__title--header", style: {
                            overflow: 'hidden',
                            whiteSpace: 'nowrap',
                            textOverflow: 'ellipsis',
                            color: ((_f = (_e = (_d = setup.chart) === null || _d === void 0 ? void 0 : _d.title) === null || _e === void 0 ? void 0 : _e.textStyle) === null || _f === void 0 ? void 0 : _f.color) || '#000',
                            fontSize: ((_j = (_h = (_g = setup.chart) === null || _g === void 0 ? void 0 : _g.title) === null || _h === void 0 ? void 0 : _h.textStyle) === null || _j === void 0 ? void 0 : _j.fontSize) || 14,
                        }, children: ((_m = (_l = (_k = setup.chart) === null || _k === void 0 ? void 0 : _k.title) === null || _l === void 0 ? void 0 : _l.text) === null || _m === void 0 ? void 0 : _m.trim()) || setup.title || '' }), _jsx("div", { className: "s-dashboard__title--description", style: {
                            fontSize: '12px',
                            color: '#666',
                            whiteSpace: 'break-spaces',
                        }, children: filterDescription })] }), _jsxs("div", { className: "s-dashboard__title--icons", children: [(viewMode === 'table' || setup.type === 'table') && (_jsx("div", { className: "s-dashboard-icon download-data-excel", children: _jsx(FaFileExcel, { size: 35, onClick: downloadFileExcel }) })), setup.table && setup.type !== 'table' && (_jsx("div", { className: "s-dashboard-icon", onClick: changeViewData, children: viewMode === 'chart' ? _jsx(FaTable, { size: 35 }) : _jsx(FaChartBar, { size: 35 }) })), setup.parameters && setup.parameters.length > 0 && (_jsx("div", { className: "s-dashboard-icon filter", children: _jsx(FaFilter, { size: 35, onClick: showFilter }) })), ((_o = setup.chart) === null || _o === void 0 ? void 0 : _o.chart_link) && setup.chart.chart_link.length > 0 && (_jsx("div", { className: "s-dashboard-icon next-dashboard", children: _jsx(FaArrowAltCircleRight, { size: 35, onClick: nextDashboard }) }))] })] }));
};
export default ChartTitle;
